/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Database.xs. Do not edit this file, edit Database.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "RPM/Database.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <fcntl.h>
#include "RPM.h"

/*
  rpmdb_TIEHASH

  This is the implementation of the tied-hash class constructor. The XS
  wrapper will verify that the value of class is correct, then massage the
  arguments as needed. The return value is expected to be either NULL or a
  valid RPM__Database value (which the XS wrapper will fix up).
*/
RPM__Database rpmdb_TIEHASH(pTHX_ char* class, SV* opts)
{
    char*  root  = (char *)NULL;
    int    mode  = O_RDONLY;
    mode_t perms = 0;
    HV*    opt_hash;
    SV**   svp;
    RPM_Database* retvalp; /* For "private" */

    if (opts)
    {
        if (SvROK(opts) && (SvTYPE(opts) == SVt_PVHV))
        {
            /* This is a hash reference. We are concerned only with
               the key "root". "mode" and "perms" don't apply, as we are
               going to open the database as read-only. */
            opt_hash = (HV*)SvRV(opts);

            svp = hv_fetch(opt_hash, "root", 4, FALSE);
            if (svp && SvPOK(*svp))
                root = SvPV_nolen(*svp);
        }
        else if (SvPOK(opts))
        {
            /* They passed a scalar, assumed to be the "root" */
            root = SvPV_nolen(opts);
        }
        else
        {
            PERL_RPM_ERROR("Wrong type for argument 2 to TIEHASH");
            return (Null(RPM__Database));
        }
    }

    /* With that all processed, attempt to open the actual RPM DB */
    /* The retvalp is used for the C-level rpmlib information on databases */
    Newz(0, retvalp, 1, RPM_Database);
#if RPM_VERSION < 0x040100
    if (rpmdbOpen(root, &retvalp->dbp, mode, perms) != 0)
    {
        Safefree(retvalp);
        /* rpm lib will have set the error already */
        return (Null(RPM__Database));
    }
#else
    /* TODO: should store prev. value if defined and restore */
    if (root) addMacro(NULL, "_dbpath", NULL, root, RMIL_DEFAULT);
    retvalp->dbp = rpmtsCreate();
    if (rpmtsOpenDB(retvalp->dbp, mode))
    {
        if (root) delMacro(NULL, "_dbpath");
        rpmtsFree(retvalp->dbp);
        Safefree(retvalp);
        /* rpm lib will have set the error already */
        return (Null(RPM__Database));
    }
    if (root) delMacro(NULL, "_dbpath");
#endif
    return retvalp;
}

RPM__Header rpmdb_FETCH(pTHX_ RPM__Database dbstruct, const char *name)
{
    Header h, hi;
    rpmdbMatchIterator mi;
    RPM__Header hdr = Null(RPM__Header);

    h = Null(Header);
#if RPM_VERSION < 0x040400
    mi = rpmdbInitIterator(dbstruct->dbp, RPMTAG_NAME, name, 0);
#else
    mi = rpmtsInitIterator(dbstruct->dbp, RPMTAG_NAME, name, 0);
#endif
    while ((hi = rpmdbNextIterator(mi)) != Null(Header))
    {
        /* There might be more than one match. Find the newest one. */
        if (h == Null(Header) || rpmVersionCompare(hi, h) == 1)
        {
            headerFree(h);
            h = headerLink(hi);
        }
    }
    rpmdbFreeIterator(mi);
    if (h)
        hdr = rpmhdr_TIEHASH_header(aTHX_ h);
    return hdr;
}

bool rpmdb_EXISTS(pTHX_ RPM__Database dbstruct, const char *name)
{
    RPM__Header hdr = rpmdb_FETCH(aTHX_ dbstruct, name);
    if (hdr) {
        rpmhdr_DESTROY(aTHX_ hdr);
        return TRUE;
    }
    return FALSE;
}

int rpmdb_FIRSTKEY(pTHX_ RPM__Database db, const char **namep, RPM__Header *hdrp)
{
    if (db->iterator)
        rpmdbFreeIterator(db->iterator);
#if RPM_VERSION < 0x040400
    db->iterator = rpmdbInitIterator(db->dbp, RPMDBI_PACKAGES, NULL, 0);
#else
    db->iterator = rpmtsInitIterator(db->dbp, RPMDBI_PACKAGES, NULL, 0);
#endif
    if (! db->iterator) {
        warn("%s: rpmdbInitIterator() failed", "RPM::Database::FIRSTKEY");
        return 0;
    }
    return rpmdb_NEXTKEY(aTHX_ db, Nullch, namep, hdrp);
}

int rpmdb_NEXTKEY(pTHX_ RPM__Database db, const char *prev_name,
                  const char **namep, RPM__Header *hdrp)
{
    Header h;
    (void) prev_name;
    if (! db->iterator) {
        warn("%s called before FIRSTKEY", "RPM::Database::NEXTKEY");
        return 0;
    }
    if (! (h = rpmdbNextIterator(db->iterator))) {
        /* That was last package.  Game over. */
        rpmdbFreeIterator(db->iterator);
        db->iterator = Null(rpmdbMatchIterator);
        return 0;
    }
    h = headerLink(h);
    *hdrp = rpmhdr_TIEHASH_header(aTHX_ h);
    *namep = (*hdrp)->name;
    return 1;
}

void rpmdb_DESTROY(pTHX_ RPM__Database db)
{
    if (db->iterator)
        rpmdbFreeIterator(db->iterator);
#if RPM_VERSION < 0x040100
    rpmdbClose(db->dbp);
#else
    rpmtsCloseDB(db->dbp);
    rpmtsFree(db->dbp);
#endif
    Safefree(db);
}

#line 175 "RPM/Database.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 319 "RPM/Database.c"

XS_EUPXS(XS_RPM__Database_TIEHASH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_TIEHASH)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, opts=NULL");
    {
	char*	class = (char *)SvPV_nolen(ST(0))
;
	SV*	opts;
	RPM__Database	RETVAL;

	if (items < 2)
	    opts = NULL;
	else {
	    opts = ST(1)
;
	}
#line 174 "RPM/Database.xs"
    RETVAL = rpmdb_TIEHASH(aTHX_ class, opts);
#line 341 "RPM/Database.c"
	{
	    SV * RETVALSV;
	    RETVALSV = rpm_ptr2hvref(aTHX_ RETVAL, "RPM::Database");
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPM__Database_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, name");
    {
	RPM__Database	self;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	RPM__Header	RETVAL;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "RPM::Database::FETCH",
                        "self", "RPM::Database");
    }
;
#line 184 "RPM/Database.xs"
    RETVAL = rpmdb_FETCH(aTHX_ self, name);
#line 375 "RPM/Database.c"
	{
	    SV * RETVALSV;
	    RETVALSV = rpm_ptr2hvref(aTHX_ RETVAL, "RPM::Header");
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPM__Database_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_STORE)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 3)
       croak_xs_usage(cv,  "self=NULL, key=NULL, value=NULL");
    {
	SV*	self;
	SV*	key;
	SV*	value;
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    self = NULL;
	else {
	    self = ST(0)
;
	}

	if (items < 2)
	    key = NULL;
	else {
	    key = ST(1)
;
	}

	if (items < 3)
	    value = NULL;
	else {
	    value = ST(2)
;
	}
#line 195 "RPM/Database.xs"
    {
        PERL_RPM_ERROR("STORE: operation not permitted");
        RETVAL = 0;
    }
#line 425 "RPM/Database.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPM__Database_DELETE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_DELETE)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 2)
       croak_xs_usage(cv,  "self=NULL, key=NULL");
    {
	SV*	self;
	SV*	key;
	SV *	RETVAL;

	if (items < 1)
	    self = NULL;
	else {
	    self = ST(0)
;
	}

	if (items < 2)
	    key = NULL;
	else {
	    key = ST(1)
;
	}
#line 208 "RPM/Database.xs"
    {
        PERL_RPM_ERROR("DELETE: operation not permitted");
        RETVAL = Nullsv;
    }
#line 462 "RPM/Database.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPM__Database_CLEAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_CLEAR)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "self=NULL");
    {
	SV*	self;
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    self = NULL;
	else {
	    self = ST(0)
;
	}
#line 220 "RPM/Database.xs"
    {
        PERL_RPM_ERROR("CLEAR: operation not permitted");
        RETVAL = 0;
    }
#line 492 "RPM/Database.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPM__Database_EXISTS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_EXISTS)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, name");
    {
	RPM__Database	self;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	bool	RETVAL;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "RPM::Database::EXISTS",
                        "self", "RPM::Database");
    }
;
#line 233 "RPM/Database.xs"
    RETVAL = rpmdb_EXISTS(aTHX_ self, name);
#line 522 "RPM/Database.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPM__Database_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_FIRSTKEY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	RPM__Database	self;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "RPM::Database::FIRSTKEY",
                        "self", "RPM::Database");
    }
;
#line 242 "RPM/Database.xs"
    {
        const char *name;
        RPM__Header hdr;

        if (rpmdb_FIRSTKEY(aTHX_ self, &name, &hdr))
        {
            EXTEND(SP, 2);
            PUSHs(sv_2mortal(rpm_ptr2hvref(aTHX_ hdr, "RPM::Header")));
            PUSHs(sv_2mortal(newSVpv(name, 0)));
        }

    }
#line 561 "RPM/Database.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_RPM__Database_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_NEXTKEY)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, prev_name=NULL");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	RPM__Database	self;
	const char *	prev_name;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "RPM::Database::NEXTKEY",
                        "self", "RPM::Database");
    }
;

	if (items < 2)
	    prev_name = NULL;
	else {
	    prev_name = (const char *)SvPV_nolen(ST(1))
;
	}
#line 261 "RPM/Database.xs"
    {
        const char *name;
        RPM__Header hdr;

        if (rpmdb_NEXTKEY(aTHX_ self, prev_name, &name, &hdr))
        {
            EXTEND(SP, 2);
            PUSHs(sv_2mortal(rpm_ptr2hvref(aTHX_ hdr, "RPM::Header")));
            PUSHs(sv_2mortal(newSVpv(name, 0)));
        }

    }
#line 608 "RPM/Database.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_RPM__Database_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	RPM__Database	self;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "RPM::Database::DESTROY",
                        "self", "RPM::Database");
    }
;
#line 279 "RPM/Database.xs"
    rpmdb_DESTROY(aTHX_ self);
#line 634 "RPM/Database.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPM__Database_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_init)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "class, root=NULL, perms=O_RDWR");
    {
	SV*	class = ST(0)
;
	const char*	root;
	int	perms;
	bool	RETVAL;

	if (items < 2)
	    root = NULL;
	else {
	    root = (const char *)SvPV_nolen(ST(1))
;
	}

	if (items < 3)
	    perms = O_RDWR;
	else {
	    perms = (int)SvIV(ST(2))
;
	}
#line 288 "RPM/Database.xs"
#if RPM_VERSION < 0x040400
    if (SvPOK(class) && strEQ(SvPV_nolen(class), "RPM::Database"))
        RETVAL = !rpmdbInit(root, perms);
    else {
        PERL_RPM_ERROR("%s must be called as a static method",
                                "RPM::Database::init");
        RETVAL = FALSE;
    }
#else
    PERL_RPM_ERROR("%s is not implemented", "RPM::Database::init");
    RETVAL = FALSE;
#endif
#line 679 "RPM/Database.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPM__Database_rebuild); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_rebuild)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, root=NULL");
    {
	SV*	class = ST(0)
;
	const char*	root;
	bool	RETVAL;

	if (items < 2)
	    root = NULL;
	else {
	    root = (const char *)SvPV_nolen(ST(1))
;
	}
#line 309 "RPM/Database.xs"
    if (SvPOK(class) && strEQ(SvPV_nolen(class), "RPM::Database"))
#if RPM_VERSION < 0x040400
#if RPM_VERSION >= 0x040100
        RETVAL = !rpmdbRebuild(root, NULL, NULL);
#else
        RETVAL = !rpmdbRebuild(root);
#endif
#else
    {
        PERL_RPM_ERROR("%s is not implemented", "RPM::Database::rebuild");
        RETVAL = FALSE;
    }
#endif
    else {
        PERL_RPM_ERROR("%s must be called as a static method",
                                "RPM::Database::rebuild");
        RETVAL = FALSE;
    }
#line 723 "RPM/Database.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPM__Database_find_by_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPM__Database_find_by_file)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, string");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	RPM__Database	self;
	SV *	string = ST(1)
;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        GvNAME(CvGV(cv)),
                        "self", "RPM::Database");
    }
;
#line 342 "RPM/Database.xs"
    /* This is a front-end to all the rpmdbFindBy*() set, including FindByPackage
       which differs from FETCH above in that if there is actually more than one
       match, all will be returned.  */
    {
        const char *str = Nullch;
        RPM_Header *hdr;

        if (ix == 0)
            ix = RPMTAG_BASENAMES;

        hdr = rpm_hvref2ptr(aTHX_ string, "RPM::Header");
        if (hdr)
            str = hdr->name;
        else
            str = SvPV_nolen(string);

        if (! (str && *str)) {
            PERL_RPM_ERROR("%s: arg 2 must be either a string"
                     " or valid RPM::Header object", GvNAME(CvGV(cv)));
        /*  Perl_warn(aTHX_ "%s", SvPV_nolen(rpm_errSV)); */
        }
        else {
#if RPM_VERSION < 0x040400
            rpmdbMatchIterator mi = rpmdbInitIterator(self->dbp, ix, str, 0);
#else
            rpmdbMatchIterator mi = rpmtsInitIterator(self->dbp, ix, str, 0);
#endif
            if (mi) {
                Header h;
                int n = rpmdbGetIteratorCount(mi);
                EXTEND(SP, n);
                while ((h = rpmdbNextIterator(mi)) != Null(Header)) {
                    h = headerLink(h);
                    hdr = rpmhdr_TIEHASH_header(aTHX_ h);
                    PUSHs(sv_2mortal(rpm_ptr2hvref(aTHX_ hdr, "RPM::Header")));
                }
                rpmdbFreeIterator(mi);
            }
        }
    }
#line 793 "RPM/Database.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_RPM__Database); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_RPM__Database)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

    {
        CV * cv;

        (void)newXSproto_portable("RPM::Database::TIEHASH", XS_RPM__Database_TIEHASH, file, "$;$");
        (void)newXSproto_portable("RPM::Database::FETCH", XS_RPM__Database_FETCH, file, "$$");
        (void)newXSproto_portable("RPM::Database::STORE", XS_RPM__Database_STORE, file, "$$$");
        (void)newXSproto_portable("RPM::Database::DELETE", XS_RPM__Database_DELETE, file, "$$");
        (void)newXSproto_portable("RPM::Database::CLEAR", XS_RPM__Database_CLEAR, file, "$");
        (void)newXSproto_portable("RPM::Database::EXISTS", XS_RPM__Database_EXISTS, file, "$$");
        (void)newXSproto_portable("RPM::Database::FIRSTKEY", XS_RPM__Database_FIRSTKEY, file, "$");
        (void)newXSproto_portable("RPM::Database::NEXTKEY", XS_RPM__Database_NEXTKEY, file, "$;$");
        (void)newXSproto_portable("RPM::Database::DESTROY", XS_RPM__Database_DESTROY, file, "$");
        (void)newXSproto_portable("RPM::Database::init", XS_RPM__Database_init, file, "$;$$");
        (void)newXSproto_portable("RPM::Database::rebuild", XS_RPM__Database_rebuild, file, "$;$");
        cv = newXSproto_portable("RPM::Database::find_by_file", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("RPM::Database::find_by_group", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = RPMTAG_GROUP;
        cv = newXSproto_portable("RPM::Database::find_by_package", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = RPMTAG_NAME;
        cv = newXSproto_portable("RPM::Database::find_what_conflicts", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = RPMTAG_CONFLICTNAME;
        cv = newXSproto_portable("RPM::Database::find_what_provides", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = RPMTAG_PROVIDENAME;
        cv = newXSproto_portable("RPM::Database::find_what_requires", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = RPMTAG_REQUIRENAME;
    }
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
